## google-perftools 2.11

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

# Please note that cmake support is very preliminary. Autotools-based
# build is the only fully supported build for now.

# Based on configure.ac

project(gperftools VERSION 2.11 LANGUAGES C CXX
        DESCRIPTION "Performance tools for C++"
        HOMEPAGE_URL https://github.com/gperftools/gperftools)

# Update this value for every release!
set(TCMALLOC_SO_VERSION 9.12.5)
set(PROFILER_SO_VERSION 5.7.5)
set(TCMALLOC_AND_PROFILER_SO_VERSION 10.7.6)

# The user can choose not to compile in the heap-profiler, the
# heap-checker, or the cpu-profiler.  There's also the possibility
# for a 'fully minimal' compile, which leaves out the stacktrace
# code as well.  By default, we include all of these that the
# target system supports.
set(DEFAULT_BUILD_CPU_PROFILER ON)
set(DEFAULT_BUILD_HEAP_PROFILER ON)
set(DEFAULT_BUILD_HEAP_CHECKER OFF)
set(DEFAULT_BUILD_DEBUGALLOC ON)
set(DEFAULT_BUILD_MINIMAL OFF)

set(DEFAULT_TCMALLOC_ALIGNMENT 16)
set(NEED_NANOSLEEP ON) # Used later, to decide if to run ACX_NANOSLEEP

set(HOST string(TOLOWER "${CMAKE_SYSTEM_NAME}"))

if(MINGW OR MSVC)
  set(DEFAULT_BUILD_MINIMAL ON)
  set(DEFAULT_BUILD_DEBUGALLOC OFF)
  set(NEED_NANOSLEEP OFF)
elseif(CYGWIN)
  set(DEFAULT_BUILD_CPU_PROFILER OFF)
endif()

# Heap checker is Linux-only (and deprecated).
if(CMAKE_SYSTEM MATCHES Linux)
  set(DEFAULT_BUILD_HEAP_CHECKER ON)
endif()

include(CheckCCompilerFlag)
include(CheckCSourceCompiles)
include(CheckCXXSourceCompiles)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(CheckTypeSize)
include(CheckVariableExists)
include(CMakeDependentOption)
include(CTest)
include(CPack)
include(GNUInstallDirs)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
include(DefineTargetVariables)
include(PCFromUContext)

define_target_variables()

# Currently only backtrace works on s390.
if(s390 OR OSX)
  set(default_enable_libunwind OFF)
  set(default_enable_backtrace ON)
else()
  set(default_enable_libunwind ON)
  set(default_enable_backtrace OFF)
endif()

# Disable libunwind linking on ppc64 by default.
if(PPC64)
  set(default_enable_libunwind OFF)
  set(default_tcmalloc_pagesize 64)
else()
  set(default_enable_libunwind ON)
  set(default_tcmalloc_pagesize 8)
endif()

cmake_dependent_option(
  GPERFTOOLS_BUILD_CPU_PROFILER "Build cpu-profiler" ${DEFAULT_BUILD_CPU_PROFILER}
  "NOT gperftools_build_minimal" OFF)
cmake_dependent_option(
  GPERFTOOLS_BUILD_HEAP_PROFILER "Build heap-profiler" ${DEFAULT_BUILD_HEAP_PROFILER}
  "NOT gperftools_build_minimal" OFF)
cmake_dependent_option(
  GPERFTOOLS_BUILD_HEAP_CHECKER "Build heap-checker" ${DEFAULT_BUILD_HEAP_CHECKER}
  "NOT gperftools_build_minimal" OFF)
cmake_dependent_option(
  GPERFTOOLS_BUILD_DEBUGALLOC "Build debugalloc" ${DEFAULT_BUILD_DEBUGALLOC}
  "NOT gperftools_build_minimal" OFF)
option(
        gperftools_build_minimal
        "Build only tcmalloc-minimal (and maybe tcmalloc-minimal-debug)"
        ${DEFAULT_BUILD_MINIMAL})
if(gperftools_build_minimal)
  set(GPERFTOOLS_BUILD_CPU_PROFILER OFF)
  set(GPERFTOOLS_BUILD_HEAP_PROFILER OFF)
  set(GPERFTOOLS_BUILD_HEAP_CHECKER OFF)
endif()

cmake_dependent_option(
  gperftools_build_benchmark "Build benchmark" ON "NOT MINGW AND NOT MSVC" OFF)

option(gperftools_enable_stacktrace_via_backtrace
       "Enable use of backtrace() for stacktrace capturing (may deadlock)"
       ${default_enable_backtrace})
option(gperftools_enable_libunwind
       "Enable libunwind linking"
       ${default_enable_libunwind})

set(enable_backtrace ${gperftools_enable_stacktrace_via_backtrace})
set(enable_libunwind ${gperftools_enable_libunwind})

set(gperftools_tcmalloc_pagesize ${default_tcmalloc_pagesize}
  CACHE STRING "Set the tcmalloc internal page size")
set_property(CACHE gperftools_tcmalloc_pagesize PROPERTY STRINGS "8" "32" "64")
if(NOT gperftools_tcmalloc_pagesize STREQUAL "8" AND
   NOT gperftools_tcmalloc_pagesize STREQUAL "32" AND
   NOT gperftools_tcmalloc_pagesize STREQUAL "64")
  message(WARNING
    "Invalid gperftools_tcmalloc_pagesize (${gperftools_tcmalloc_pagesize}), "
    "setting to default value (${default_tcmalloc_pagesize})")
  set(gperftools_tcmalloc_pagesize ${default_tcmalloc_pagesize})
endif()
if (gperftools_tcmalloc_pagesize STREQUAL "32" OR
  gperftools_tcmalloc_pagesize STREQUAL "64")
  set(TCMALLOC_${gperftools_tcmalloc_pagesize}K_PAGES ON)
endif()

set(gperftools_tcmalloc_alignment ${DEFAULT_TCMALLOC_ALIGNMENT}
  CACHE STRING "Set the tcmalloc allocation alignment")
set_property(CACHE gperftools_tcmalloc_alignment PROPERTY STRINGS "8" "16")
if(NOT gperftools_tcmalloc_alignment STREQUAL "8" AND
   NOT gperftools_tcmalloc_alignment STREQUAL "16")
  message(WARNING
      "Invalid gperftools_tcmalloc_alignment (${gperftools_tcmalloc_alignment}), "
      "setting to default value (${DEFAULT_TCMALLOC_ALIGNMENT})")
  set(gperftools_tcmalloc_alignment ${DEFAULT_TCMALLOC_ALIGNMENT})
endif()
if(gperftools_tcmalloc_alignment STREQUAL "8")
  set(TCMALLOC_ALIGN_8BYTES ON)
endif()

# AX_CXX_COMPILE_STDCXX(11, ext, mandatory)
if(cxx_std_17 IN_LIST CMAKE_CXX_COMPILE_FEATURES)
  set(CMAKE_CXX_STANDARD 17) # std::align_val_t
else()
  set(CMAKE_CXX_STANDARD 11)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS ON)

# AX_C___ATTRIBUTE__
check_c_source_compiles("#include <stdlib.h>
                         static void foo(void) __attribute__ ((unused));
                         void foo(void) { exit(1); }
                         int main() { return 0; }"
        HAVE___ATTRIBUTE__)

set(CMAKE_EXTRA_INCLUDE_FILES "malloc.h")
check_type_size("struct mallinfo" STRUCT_MALLINFO LANGUAGE CXX)
set(CMAKE_EXTRA_INCLUDE_FILES "elf.h")
check_type_size("Elf32_Versym" ELF32_VERSYM LANGUAGE CXX) # for vdso_support.h
set(CMAKE_EXTRA_INCLUDE_FILES)
check_function_exists("sbrk" HAVE_SBRK) # for tcmalloc to get memory
check_function_exists("__sbrk" HAVE___SBRK) # for tcmalloc to get memory
check_function_exists("geteuid" HAVE_GETEUID) # for turning off services when run as root
check_function_exists("fork" HAVE_FORK) # for the pthread_atfork setup
check_include_file("features.h" HAVE_FEATURES_H) # for vdso_support.h, Where __GLIBC__ is defined
check_include_file("malloc.h" HAVE_MALLOC_H) # some systems define stuff there, others not
check_include_file("glob.h" HAVE_GLOB_H) # for heap-profile-table (cleaning up profiles)
check_include_file("execinfo.h" HAVE_EXECINFO_H) # for stacktrace? and heapchecker_unittest
check_include_file("unwind.h" HAVE_UNWIND_H) # for stacktrace
check_include_file("sched.h" HAVE_SCHED_H) # for being nice in our spinlock code
check_include_file("sys/syscall.h" HAVE_SYS_SYSCALL_H)
check_include_file("sys/socket.h" HAVE_SYS_SOCKET_H) # optional; for forking out to symbolizer
check_include_file("sys/wait.h" HAVE_SYS_WAIT_H) # optional; for forking out to symbolizer
check_include_file("poll.h" HAVE_POLL_H) # optional; for forking out to symbolizer
check_include_file("fcntl.h" HAVE_FCNTL_H) # for tcmalloc_unittest
check_include_file("grp.h" HAVE_GRP_H) # for heapchecker_unittest
check_include_file("pwd.h" HAVE_PWD_H) # for heapchecker_unittest
check_include_file("sys/resource.h" HAVE_SYS_RESOURCE_H) # for memalign_unittest.cc
check_include_file("sys/cdefs.h" HAVE_SYS_CDEFS_H) # Where glibc defines __THROW

check_include_file("unistd.h" HAVE_UNISTD_H)
# We also need <ucontext.h>/<sys/ucontext.h>, but we get those from
# AC_PC_FROM_UCONTEXT, below.

# We override a lot of memory allocation routines, not all of which are
# standard.  For those the system doesn't declare, we'll declare ourselves.
set(CMAKE_REQUIRED_DEFINITIONS -D_XOPEN_SOURCE=600)
check_symbol_exists("cfree" "stdlib.h;malloc.h" HAVE_DECL_CFREE)
check_symbol_exists("posix_memalign" "stdlib.h;malloc.h" HAVE_DECL_POSIX_MEMALIGN)
check_symbol_exists("memalign" "stdlib.h;malloc.h" HAVE_DECL_MEMALIGN)
check_symbol_exists("valloc" "stdlib.h;malloc.h" HAVE_DECL_VALLOC)
check_symbol_exists("pvalloc" "stdlib.h;malloc.h" HAVE_DECL_PVALLOC)
set(CMAKE_REQUIRED_DEFINITIONS)

if(HAVE_STRUCT_MALLINFO)
    set(HAVE_STRUCT_MALLINFO 1)
else()
    set(HAVE_STRUCT_MALLINFO 0)
endif()

# We hardcode HAVE_MMAP to 1. There are no interesting systems anymore
# without functional mmap. And our windows (except mingw) builds
# aren't using autoconf. So we keep HAVE_MMAP define, but only to
# distingush windows and rest.
if(NOT WIN32)
  set(HAVE_MMAP 1)
endif()

# We want to access the "PC" (Program Counter) register from a struct
# ucontext.  Every system has its own way of doing that.  We try all the
# possibilities we know about.  Note REG_PC should come first (REG_RIP
# is also defined on solaris, but does the wrong thing).  But don't
# bother if we're not doing cpu-profiling.
# [*] means that we've not actually tested one of these systems
if (GPERFTOOLS_BUILD_CPU_PROFILER)
  pc_from_ucontext(PC_FROM_UCONTEXT_DEF)
endif ()

# Some tests test the behavior of .so files, and only make sense for dynamic.
option(GPERFTOOLS_BUILD_STATIC "Enable Static" ON)

if(gperftools_enable_libunwind)
  check_include_file("libunwind.h" HAVE_LIBUNWIND_H)
  if(HAVE_LIBUNWIND_H)
    find_library(libunwind_location NAMES unwind)
    if(libunwind_location)
      check_library_exists(
        unwind backtrace ${libunwind_location} have_libunwind)
    endif()
    if(have_libunwind)
      set(unwind_libs ${libunwind_location})
      set(will_use_libunwind ON)
      set(USE_LIBUNWIND 1)
    endif()
  endif()
endif()

# See if the compiler supports -Wno-unused-result.
# Newer ubuntu's turn on -D_FORTIFY_SOURCE=2, enabling
# __attribute__((warn_unused_result)) for things like write(),
# which we don't care about.
check_c_compiler_flag("-Wno-unused-result" have_w_no_unused_result)

check_c_compiler_flag("-fno-omit-frame-pointer -momit-leaf-frame-pointer" have_omit_leaf_fp)
check_c_source_compiles("
  #if !(__i386__ || __x86_64__ || __riscv || __aarch64__)
  #error unsupported arch
  #endif
  int main() { return 0; }
  "
  use_omit_leaf_fp)

if (use_omit_leaf_fp)
  add_compile_options(-fno-omit-frame-pointer -momit-leaf-frame-pointer)
endif()

option(gperftools_dynamic_sized_delete_support
       "Try to build run-time switch for sized delete operator"
       OFF)
if(gperftools_dynamic_sized_delete_support)
  set(ENABLE_DYNAMIC_SIZED_DELETE 1)
endif()

option(gperftools_sized_delete "Build sized delete operator" OFF)
if(gperftools_sized_delete)
  set(ENABLE_SIZED_DELETE 1)
endif()

if(NOT MSVC)
  set(CMAKE_REQUIRED_FLAGS -fsized-deallocation)
  check_cxx_source_compiles("
  #include <new>
  int main() { (::operator delete)(0, 256); return 0; }"
          have_sized_deallocation)
  set(CMAKE_REQUIRED_FLAGS)
endif()

check_cxx_source_compiles("
  #include <new>
  int main() { (::operator delete)((::operator new)(256, std::align_val_t(16)), std::align_val_t(16)); return 0; }"
  HAVE_STD_ALIGN_VAL_T)
if(HAVE_STD_ALIGN_VAL_T)
  set(HAVE_STD_ALIGN_VAL_T 1)
else()
  set(HAVE_STD_ALIGN_VAL_T 0)
endif()

check_c_source_compiles("
  #include <unwind.h>
  int main()
  {
#if __APPLE__ || __FreeBSD__
#error OSX _Unwind_Backtrace recurses back to malloc
#endif
    &_Unwind_Backtrace;
    return 0;
  }"
  HAVE_UNWIND_BACKTRACE)

if(enable_backtrace)
  set(default_emergency_malloc ON)
else()
  set(default_emergency_malloc OFF)
endif()

if(will_use_libunwind AND ARM)
  set(default_emergency_malloc ON)
endif()

option(gperftools_emergency_malloc
       "Build emergency malloc"
       ${default_emergency_malloc})

check_c_source_compiles(
  "int main() { return __builtin_expect(main != 0, 1); }"
  HAVE_BUILTIN_EXPECT)

check_c_source_compiles("
  #include <unistd.h>
  int main()
  {
    char** env = __environ;
    return 0;
  }"
  HAVE___ENVIRON)

# If we support __thread, that can speed up tcmalloc a bit.
# Note, however, that our code tickles a bug in gcc < 4.1.2
# involving TLS and -fPIC (which our libraries will use) on x86:

## google-perftools 2.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,14 +5,14 @@
 
 # Based on configure.ac
 
-project(gperftools VERSION 2.11 LANGUAGES C CXX
+project(gperftools VERSION 2.12 LANGUAGES C CXX
         DESCRIPTION "Performance tools for C++"
         HOMEPAGE_URL https://github.com/gperftools/gperftools)
 
 # Update this value for every release!
-set(TCMALLOC_SO_VERSION 9.12.5)
-set(PROFILER_SO_VERSION 5.7.5)
-set(TCMALLOC_AND_PROFILER_SO_VERSION 10.7.6)
+set(TCMALLOC_SO_VERSION 9.13.5)
+set(PROFILER_SO_VERSION 5.8.5)
+set(TCMALLOC_AND_PROFILER_SO_VERSION 10.8.6)
 
 # The user can choose not to compile in the heap-profiler, the
 # heap-checker, or the cpu-profiler.  There's also the possibility

## google-perftools 2.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,14 +5,14 @@
 
 # Based on configure.ac
 
-project(gperftools VERSION 2.12 LANGUAGES C CXX
+project(gperftools VERSION 2.13 LANGUAGES C CXX
         DESCRIPTION "Performance tools for C++"
         HOMEPAGE_URL https://github.com/gperftools/gperftools)
 
 # Update this value for every release!
-set(TCMALLOC_SO_VERSION 9.13.5)
-set(PROFILER_SO_VERSION 5.8.5)
-set(TCMALLOC_AND_PROFILER_SO_VERSION 10.8.6)
+set(TCMALLOC_SO_VERSION 9.14.5)
+set(PROFILER_SO_VERSION 5.9.5)
+set(TCMALLOC_AND_PROFILER_SO_VERSION 10.9.6)
 
 # The user can choose not to compile in the heap-profiler, the
 # heap-checker, or the cpu-profiler.  There's also the possibility

=== debian/changelog ===
google-perftools (2.13-1) unstable; urgency=medium

  * New upstream release.
  * No more needed to link with atomic.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 14 Sep 2023 13:32:35 +0000

google-perftools (2.12-2) unstable; urgency=medium

  * Link with atomic on armel and powerpc architectures.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 06 Sep 2023 06:21:39 +0000

google-perftools (2.12-1) unstable; urgency=medium

  * New upstream release.
  * Disable profiler_unittest for now due to i386 failures.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 05 Sep 2023 14:33:40 +0000

google-perftools (2.11-1) unstable; urgency=medium

  * New upstream release.
  * Add HTML documentation (closes: #754380).
  * Use no for Rules-Requires-Root.
  * Update Standards-Version to 4.6.2 .

  [ Debian Janitor <janitor@jelmer.uk> ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Remove field Section on binary packages libgoogle-perftools4,
    libtcmalloc-minimal4 that duplicates source.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 15 Aug 2023 18:06:40 +0200

=== debian/control ===
Source: google-perftools
Section: libs
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends: debhelper-compat (= 13), libunwind-dev [amd64]
Build-Conflicts: autoconf2.13, automake1.4
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/gperftools/gperftools
Vcs-Git: https://salsa.debian.org/debian/google-perftools.git
Vcs-Browser: https://salsa.debian.org/debian/google-perftools

Package: libgoogle-perftools-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libgoogle-perftools4 (= ${binary:Version}), libtcmalloc-minimal4 (= ${binary:Version}), libunwind-dev [amd64]
Multi-Arch: same
Description: libraries for CPU and heap analysis, plus an efficient thread-caching malloc
 The gperftools, previously called google-perftools, package contains some
 utilities to improve and analyze the performance of C++ programs.  This
 includes an optimized thread-caching malloc() and cpu and heap profiling
 utilities.  The devel package contains static and debug libraries and header
 files for developing applications that use the google-perftools package.

Package: libtcmalloc-minimal4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: efficient thread-caching malloc
 The gperftools, previously called google-perftools, package contains some
 utilities to improve and analyze the performance of C++ programs. This is a
 part of that package, and includes an optimized thread-caching malloc.

Package: libgoogle-perftools4
Architecture: any
Depends: libtcmalloc-minimal4 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Conflicts: libgoogle-perftools0
Multi-Arch: same
Description: libraries for CPU and heap analysis, plus an efficient thread-caching malloc
 The gperftools, previously called google-perftools, package contains some
 utilities to improve and analyze the performance of C++ programs. This includes
 the full features: an optimized thread-caching malloc() and cpu and heap
 profiling utilities.

Package: google-perftools
Section: devel
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}, libgoogle-perftools4, curl
Suggests: libgoogle-perftools-dev
Recommends: graphviz, gv
Description: command line utilities to analyze the performance of C++ programs
 The gperftools, previously called google-perftools, package contains some
 utilities to improve and analyze the performance of C++ programs. This is a
 part of that package, and includes command line utilities.

## google-perftools 2.15

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,14 +5,14 @@
 
 # Based on configure.ac
 
-project(gperftools VERSION 2.13 LANGUAGES C CXX
+project(gperftools VERSION 2.15 LANGUAGES C CXX
         DESCRIPTION "Performance tools for C++"
         HOMEPAGE_URL https://github.com/gperftools/gperftools)
 
 # Update this value for every release!
-set(TCMALLOC_SO_VERSION 9.14.5)
-set(PROFILER_SO_VERSION 5.9.5)
-set(TCMALLOC_AND_PROFILER_SO_VERSION 10.9.6)
+set(TCMALLOC_SO_VERSION 9.16.5)
+set(PROFILER_SO_VERSION 5.11.5)
+set(TCMALLOC_AND_PROFILER_SO_VERSION 10.11.6)
 
 # The user can choose not to compile in the heap-profiler, the
 # heap-checker, or the cpu-profiler.  There's also the possibility
@@ -44,6 +44,7 @@
 endif()
 
 include(CheckCCompilerFlag)
+include(CheckCXXCompilerFlag)
 include(CheckCSourceCompiles)
 include(CheckCXXSourceCompiles)
 include(CheckFunctionExists)
@@ -59,7 +60,6 @@
 
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 include(DefineTargetVariables)
-include(PCFromUContext)
 
 define_target_variables()
 
@@ -77,7 +77,11 @@
   set(default_enable_libunwind OFF)
   set(default_tcmalloc_pagesize 64)
 else()
-  set(default_enable_libunwind ON)
+  if(PPC)
+    set(default_enable_libunwind OFF)
+  else()
+    set(default_enable_libunwind ON)
+  endif()
   set(default_tcmalloc_pagesize 8)
 endif()
 
@@ -116,20 +120,38 @@
 set(enable_backtrace ${gperftools_enable_stacktrace_via_backtrace})
 set(enable_libunwind ${gperftools_enable_libunwind})
 
+option(gperftools_enable_libgcc_unwinder_by_default
+       "Prefer libgcc's _Unwind_Backtrace as default stacktrace capturing method"
+       OFF)
+set(PREFER_LIBGCC_UNWINDER ${gperftools_enable_libgcc_unwinder_by_default})
+
 set(gperftools_tcmalloc_pagesize ${default_tcmalloc_pagesize}
   CACHE STRING "Set the tcmalloc internal page size")
-set_property(CACHE gperftools_tcmalloc_pagesize PROPERTY STRINGS "8" "32" "64")
-if(NOT gperftools_tcmalloc_pagesize STREQUAL "8" AND
-   NOT gperftools_tcmalloc_pagesize STREQUAL "32" AND
-   NOT gperftools_tcmalloc_pagesize STREQUAL "64")
+set(allowed_page_sizes LIST "4;8;16;32;64;128;256")
+set_property(CACHE gperftools_tcmalloc_pagesize PROPERTY STRINGS ${allowed_page_sizes})
+if(NOT gperftools_tcmalloc_pagesize IN_LIST allowed_page_sizes)
   message(WARNING
     "Invalid gperftools_tcmalloc_pagesize (${gperftools_tcmalloc_pagesize}), "
     "setting to default value (${default_tcmalloc_pagesize})")
   set(gperftools_tcmalloc_pagesize ${default_tcmalloc_pagesize})
 endif()
-if (gperftools_tcmalloc_pagesize STREQUAL "32" OR
-  gperftools_tcmalloc_pagesize STREQUAL "64")
-  set(TCMALLOC_${gperftools_tcmalloc_pagesize}K_PAGES ON)
+if (gperftools_tcmalloc_pagesize EQUAL 4)
+  set(TCMALLOC_PAGE_SIZE_SHIFT 12)
+elseif(gperftools_tcmalloc_pagesize EQUAL 8)
+  # default page size
+elseif(gperftools_tcmalloc_pagesize EQUAL 16)
+  set(TCMALLOC_PAGE_SIZE_SHIFT 14)
+elseif(gperftools_tcmalloc_pagesize EQUAL 32)
+  set(TCMALLOC_PAGE_SIZE_SHIFT 15)
+elseif(gperftools_tcmalloc_pagesize EQUAL 64)
+  set(TCMALLOC_PAGE_SIZE_SHIFT 16)
+elseif(gperftools_tcmalloc_pagesize EQUAL 128)
+  set(TCMALLOC_PAGE_SIZE_SHIFT 17)
+elseif(gperftools_tcmalloc_pagesize EQUAL 256)
+  set(TCMALLOC_PAGE_SIZE_SHIFT 18)
+else()
+  message(WARNING
+  "${gperftools_tcmalloc_pagesize}K size not supported, using default tcmalloc page size.")
 endif()
 
 set(gperftools_tcmalloc_alignment ${DEFAULT_TCMALLOC_ALIGNMENT}
@@ -162,8 +184,15 @@
                          int main() { return 0; }"
         HAVE___ATTRIBUTE__)
 
+check_c_source_compiles("#include <stdlib.h>
+                        void foo(void) __attribute__((aligned(128)));
+                        void foo(void) { exit(1); }
+                        int main() { return 0; }"
+        HAVE___ATTRIBUTE__ALIGNED_FN) 
+
 set(CMAKE_EXTRA_INCLUDE_FILES "malloc.h")
 check_type_size("struct mallinfo" STRUCT_MALLINFO LANGUAGE CXX)
+check_type_size("struct mallinfo2" STRUCT_MALLINFO2 LANGUAGE CXX)
 set(CMAKE_EXTRA_INCLUDE_FILES "elf.h")
 check_type_size("Elf32_Versym" ELF32_VERSYM LANGUAGE CXX) # for vdso_support.h
 set(CMAKE_EXTRA_INCLUDE_FILES)
@@ -187,6 +216,11 @@
 check_include_file("sys/resource.h" HAVE_SYS_RESOURCE_H) # for memalign_unittest.cc
 check_include_file("sys/cdefs.h" HAVE_SYS_CDEFS_H) # Where glibc defines __THROW
 
+check_include_file("sys/ucontext.h" HAVE_SYS_UCONTEXT_H)
+check_include_file("ucontext.h" HAVE_UCONTEXT_H)
+check_include_file("cygwin/signal.h" HAVE_CYGWIN_SIGNAL_H) # ucontext on cywgin
+check_include_file("asm/ptrace.h" HAVE_ASM_PTRACE_H) # get ptrace macros, e.g. PT_NIP
+
 check_include_file("unistd.h" HAVE_UNISTD_H)
 # We also need <ucontext.h>/<sys/ucontext.h>, but we get those from
 # AC_PC_FROM_UCONTEXT, below.
@@ -207,6 +241,12 @@
     set(HAVE_STRUCT_MALLINFO 0)
 endif()
 
+if(HAVE_STRUCT_MALLINFO2)
+    set(HAVE_STRUCT_MALLINFO2 1)
+else()
+    set(HAVE_STRUCT_MALLINFO2 0)
+endif()
+
 # We hardcode HAVE_MMAP to 1. There are no interesting systems anymore
 # without functional mmap. And our windows (except mingw) builds
 # aren't using autoconf. So we keep HAVE_MMAP define, but only to
@@ -214,16 +254,6 @@
 if(NOT WIN32)
   set(HAVE_MMAP 1)
 endif()
-
-# We want to access the "PC" (Program Counter) register from a struct
-# ucontext.  Every system has its own way of doing that.  We try all the
-# possibilities we know about.  Note REG_PC should come first (REG_RIP
-# is also defined on solaris, but does the wrong thing).  But don't
-# bother if we're not doing cpu-profiling.
-# [*] means that we've not actually tested one of these systems
-if (GPERFTOOLS_BUILD_CPU_PROFILER)
-  pc_from_ucontext(PC_FROM_UCONTEXT_DEF)
-endif ()
 
 # Some tests test the behavior of .so files, and only make sense for dynamic.
 option(GPERFTOOLS_BUILD_STATIC "Enable Static" ON)
@@ -290,49 +320,3 @@
   HAVE_STD_ALIGN_VAL_T)
 if(HAVE_STD_ALIGN_VAL_T)
   set(HAVE_STD_ALIGN_VAL_T 1)
-else()
-  set(HAVE_STD_ALIGN_VAL_T 0)
-endif()
-
-check_c_source_compiles("
-  #include <unwind.h>
-  int main()
-  {
-#if __APPLE__ || __FreeBSD__
-#error OSX _Unwind_Backtrace recurses back to malloc
-#endif
-    &_Unwind_Backtrace;
-    return 0;
-  }"
-  HAVE_UNWIND_BACKTRACE)
-
-if(enable_backtrace)
-  set(default_emergency_malloc ON)
-else()
-  set(default_emergency_malloc OFF)
-endif()
-
-if(will_use_libunwind AND ARM)
-  set(default_emergency_malloc ON)
-endif()
-
-option(gperftools_emergency_malloc
-       "Build emergency malloc"
-       ${default_emergency_malloc})
-
-check_c_source_compiles(
-  "int main() { return __builtin_expect(main != 0, 1); }"
-  HAVE_BUILTIN_EXPECT)
-
-check_c_source_compiles("
-  #include <unistd.h>
-  int main()
-  {
-    char** env = __environ;
-    return 0;
-  }"
-  HAVE___ENVIRON)
-
-# If we support __thread, that can speed up tcmalloc a bit.
-# Note, however, that our code tickles a bug in gcc < 4.1.2
-# involving TLS and -fPIC (which our libraries will use) on x86:

=== debian/changelog ===
google-perftools (2.15-3build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:16:59 +0000

google-perftools (2.15-3) unstable; urgency=medium

  * Also disable _TIME_BITS in mmap_hook.cc to fix FTBFS on armel / armhf.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 07 Mar 2024 22:26:10 +0100

google-perftools (2.15-2) unstable; urgency=medium

  * Backport upstream fix for FTBFS on armel / armhf with disabling
    _FILE_OFFSET_BITS in mmap_hook.cc (closes: #1065167).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 02 Mar 2024 08:28:41 +0100

google-perftools (2.15-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062116

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 22:45:25 +0000

google-perftools (2.15-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 07 Jan 2024 11:18:34 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: google-perftools
 Section: libs
 Priority: optional
-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Build-Depends: debhelper-compat (= 13), libunwind-dev [amd64]
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), libunwind-dev [amd64]
 Build-Conflicts: autoconf2.13, automake1.4
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
@@ -13,7 +14,7 @@
 Package: libgoogle-perftools-dev
 Section: libdevel
 Architecture: any
-Depends: ${misc:Depends}, libgoogle-perftools4 (= ${binary:Version}), libtcmalloc-minimal4 (= ${binary:Version}), libunwind-dev [amd64]
+Depends: ${misc:Depends}, libgoogle-perftools4t64 (= ${binary:Version}), libtcmalloc-minimal4t64 (= ${binary:Version}), libunwind-dev [amd64]
 Multi-Arch: same
 Description: libraries for CPU and heap analysis, plus an efficient thread-caching malloc
  The gperftools, previously called google-perftools, package contains some
@@ -22,7 +23,10 @@
  utilities.  The devel package contains static and debug libraries and header
  files for developing applications that use the google-perftools package.
 
-Package: libtcmalloc-minimal4
+Package: libtcmalloc-minimal4t64
+Provides: ${t64:Provides}
+Replaces: libtcmalloc-minimal4
+Breaks: libtcmalloc-minimal4 (<< ${source:Version})
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Multi-Arch: same
@@ -31,9 +35,12 @@
  utilities to improve and analyze the performance of C++ programs. This is a
  part of that package, and includes an optimized thread-caching malloc.
 
-Package: libgoogle-perftools4
+Package: libgoogle-perftools4t64
+Provides: ${t64:Provides}
+Replaces: libgoogle-perftools4
+Breaks: libgoogle-perftools4 (<< ${source:Version})
 Architecture: any
-Depends: libtcmalloc-minimal4 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: libtcmalloc-minimal4t64 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Conflicts: libgoogle-perftools0
 Multi-Arch: same
 Description: libraries for CPU and heap analysis, plus an efficient thread-caching malloc
@@ -45,7 +52,7 @@
 Package: google-perftools
 Section: devel
 Architecture: all
-Depends: ${misc:Depends}, ${perl:Depends}, libgoogle-perftools4, curl
+Depends: ${misc:Depends}, ${perl:Depends}, libgoogle-perftools4t64, curl
 Suggests: libgoogle-perftools-dev
 Recommends: graphviz, gv
 Description: command line utilities to analyze the performance of C++ programs

## google-perftools 2.16

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,14 +5,14 @@
 
 # Based on configure.ac
 
-project(gperftools VERSION 2.15 LANGUAGES C CXX
+project(gperftools VERSION 2.16 LANGUAGES C CXX
         DESCRIPTION "Performance tools for C++"
         HOMEPAGE_URL https://github.com/gperftools/gperftools)
 
 # Update this value for every release!
-set(TCMALLOC_SO_VERSION 9.16.5)
-set(PROFILER_SO_VERSION 5.11.5)
-set(TCMALLOC_AND_PROFILER_SO_VERSION 10.11.6)
+set(TCMALLOC_SO_VERSION 9.18.5)
+set(PROFILER_SO_VERSION 5.13.5)
+set(TCMALLOC_AND_PROFILER_SO_VERSION 10.13.6)
 
 # The user can choose not to compile in the heap-profiler, the
 # heap-checker, or the cpu-profiler.  There's also the possibility
@@ -26,14 +26,12 @@
 set(DEFAULT_BUILD_MINIMAL OFF)
 
 set(DEFAULT_TCMALLOC_ALIGNMENT 16)
-set(NEED_NANOSLEEP ON) # Used later, to decide if to run ACX_NANOSLEEP
 
 set(HOST string(TOLOWER "${CMAKE_SYSTEM_NAME}"))
 
 if(MINGW OR MSVC)
   set(DEFAULT_BUILD_MINIMAL ON)
   set(DEFAULT_BUILD_DEBUGALLOC OFF)
-  set(NEED_NANOSLEEP OFF)
 elseif(CYGWIN)
   set(DEFAULT_BUILD_CPU_PROFILER OFF)
 endif()
@@ -55,8 +53,8 @@
 include(CheckVariableExists)
 include(CMakeDependentOption)
 include(CTest)
-include(CPack)
-include(GNUInstallDirs)
+
+option(BUILD_SHARED_LIBS "Build using shared libraries" ON)
 
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 include(DefineTargetVariables)
@@ -168,12 +166,7 @@
   set(TCMALLOC_ALIGN_8BYTES ON)
 endif()
 
-# AX_CXX_COMPILE_STDCXX(11, ext, mandatory)
-if(cxx_std_17 IN_LIST CMAKE_CXX_COMPILE_FEATURES)
-  set(CMAKE_CXX_STANDARD 17) # std::align_val_t
-else()
-  set(CMAKE_CXX_STANDARD 11)
-endif()
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS ON)
 
@@ -193,13 +186,8 @@
 set(CMAKE_EXTRA_INCLUDE_FILES "malloc.h")
 check_type_size("struct mallinfo" STRUCT_MALLINFO LANGUAGE CXX)
 check_type_size("struct mallinfo2" STRUCT_MALLINFO2 LANGUAGE CXX)
-set(CMAKE_EXTRA_INCLUDE_FILES "elf.h")
-check_type_size("Elf32_Versym" ELF32_VERSYM LANGUAGE CXX) # for vdso_support.h
-set(CMAKE_EXTRA_INCLUDE_FILES)
 check_function_exists("sbrk" HAVE_SBRK) # for tcmalloc to get memory
-check_function_exists("__sbrk" HAVE___SBRK) # for tcmalloc to get memory
 check_function_exists("geteuid" HAVE_GETEUID) # for turning off services when run as root
-check_function_exists("fork" HAVE_FORK) # for the pthread_atfork setup
 check_include_file("features.h" HAVE_FEATURES_H) # for vdso_support.h, Where __GLIBC__ is defined
 check_include_file("malloc.h" HAVE_MALLOC_H) # some systems define stuff there, others not
 check_include_file("glob.h" HAVE_GLOB_H) # for heap-profile-table (cleaning up profiles)
@@ -211,9 +199,6 @@
 check_include_file("sys/wait.h" HAVE_SYS_WAIT_H) # optional; for forking out to symbolizer
 check_include_file("poll.h" HAVE_POLL_H) # optional; for forking out to symbolizer
 check_include_file("fcntl.h" HAVE_FCNTL_H) # for tcmalloc_unittest
-check_include_file("grp.h" HAVE_GRP_H) # for heapchecker_unittest
-check_include_file("pwd.h" HAVE_PWD_H) # for heapchecker_unittest
-check_include_file("sys/resource.h" HAVE_SYS_RESOURCE_H) # for memalign_unittest.cc
 check_include_file("sys/cdefs.h" HAVE_SYS_CDEFS_H) # Where glibc defines __THROW
 
 check_include_file("sys/ucontext.h" HAVE_SYS_UCONTEXT_H)
@@ -254,9 +239,6 @@
 if(NOT WIN32)
   set(HAVE_MMAP 1)
 endif()
-
-# Some tests test the behavior of .so files, and only make sense for dynamic.
-option(GPERFTOOLS_BUILD_STATIC "Enable Static" ON)
 
 if(gperftools_enable_libunwind)
   check_include_file("libunwind.h" HAVE_LIBUNWIND_H)
@@ -274,12 +256,6 @@
   endif()
 endif()
 
-# See if the compiler supports -Wno-unused-result.
-# Newer ubuntu's turn on -D_FORTIFY_SOURCE=2, enabling
-# __attribute__((warn_unused_result)) for things like write(),
-# which we don't care about.
-check_c_compiler_flag("-Wno-unused-result" have_w_no_unused_result)
-
 check_c_compiler_flag("-fno-omit-frame-pointer -momit-leaf-frame-pointer" have_omit_leaf_fp)
 check_c_source_compiles("
   #if !(__i386__ || __x86_64__ || __riscv || __aarch64__)
@@ -314,9 +290,62 @@
   set(CMAKE_REQUIRED_FLAGS)
 endif()
 
-check_cxx_source_compiles("
-  #include <new>
-  int main() { (::operator delete)((::operator new)(256, std::align_val_t(16)), std::align_val_t(16)); return 0; }"
-  HAVE_STD_ALIGN_VAL_T)
-if(HAVE_STD_ALIGN_VAL_T)
-  set(HAVE_STD_ALIGN_VAL_T 1)
+check_c_source_compiles("
+  #include <unwind.h>
+  int main()
+  {
+#if __APPLE__ || __FreeBSD__
+#error OSX _Unwind_Backtrace recurses back to malloc
+#endif
+    &_Unwind_Backtrace;
+    return 0;
+  }"
+  HAVE_UNWIND_BACKTRACE)
+
+if(enable_backtrace)
+  set(default_emergency_malloc ON)
+else()
+  set(default_emergency_malloc OFF)
+endif()
+
+if(will_use_libunwind AND ARM)
+  set(default_emergency_malloc ON)
+endif()
+
+option(gperftools_emergency_malloc
+       "Build emergency malloc"
+       ${default_emergency_malloc})
+
+check_c_source_compiles(
+  "int main() { return __builtin_expect(main != 0, 1); }"
+  HAVE_BUILTIN_EXPECT)
+
+check_c_source_compiles("
+  #include <unistd.h>
+  int main()
+  {
+    char** env = __environ;
+    return 0;
+  }"
+  HAVE___ENVIRON)
+
+if(enable_backtrace)
+  check_symbol_exists("backtrace" "execinfo.h" HAVE_DECL_BACKTRACE)
+  check_function_exists("backtrace" backtrace_exists)
+  if(NOT backtrace_exists)
+    set(CMAKE_REQUIRED_LIBRARIES execinfo)
+    check_function_exists("backtrace" backtrace_exists)
+    set(CMAKE_REQUIRED_LIBRARIES)
+    if(backtrace_exists)
+      list(INSERT unwind_libs 0 execinfo)
+    endif()
+  endif()
+endif()
+
+find_package(Threads REQUIRED)
+link_libraries(Threads::Threads)
+
+check_variable_exists("program_invocation_name" HAVE_PROGRAM_INVOCATION_NAME)
+
+if(MINGW)
+  check_symbol_exists("sleep" "unistd.h" HAVE_DECL_SLEEP)

=== debian/changelog ===
google-perftools (2.16-1) unstable; urgency=medium

  * New upstream release.
  * Remove patches applied upstream.
  * Update disable_profiler_unittest.patch .
  * Update Lintian overrides.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 27 Sep 2024 00:36:16 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: google-perftools
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), libunwind-dev [amd64]
 Build-Conflicts: autoconf2.13, automake1.4
 Standards-Version: 4.6.2

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

TEST_ARCHS = i386 amd64

DESTDIR = $(CURDIR)/debian/tmp

override_dh_auto_install:
	dh_auto_install
	# rename binary
	cd $(DESTDIR)/usr/bin && mv pprof google-pprof
	cd $(DESTDIR)/usr/share/man/man1 && \
		mv pprof.1 google-pprof.1 && \
		sed -i 's/pprof/google-pprof/g' google-pprof.1
	cd $(DESTDIR)/usr/share/doc/gperftools/ && \
		sed -i 's/pprof/google-pprof/g' README
	# remove unwanted documentation
	cd $(DESTDIR)/usr/share/doc/gperftools/ && \
		rm -f ChangeLog ChangeLog.old INSTALL README_windows.txt TODO
	# remove .la files
	find $(DESTDIR) -name \*.la -exec rm {} \;

override_dh_auto_test:
ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
# List of architectures for which test execution is enabled
ifneq (,$(findstring $(DEB_HOST_ARCH), $(TEST_ARCHS)))
	$(MAKE) check
endif # TEST_ARCHS
endif # nocheck

%:
	dh $@

.PHONY: override_dh_auto_install override_dh_auto_test

=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)[\-\.]?\d*)$/$1~$2/,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$// \
https://github.com/gperftools/gperftools/tags \
(?:|.*/)gperftools-v?(\d\S*)@ARCHIVE_EXT@

## google-perftools 2.18

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,25 +3,18 @@
 # Please note that cmake support is very preliminary. Autotools-based
 # build is the only fully supported build for now.
 
-# Based on configure.ac
-
-project(gperftools VERSION 2.16 LANGUAGES C CXX
+set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Choose the build type")
+
+project(gperftools VERSION 2.18 LANGUAGES C CXX
         DESCRIPTION "Performance tools for C++"
         HOMEPAGE_URL https://github.com/gperftools/gperftools)
 
-# Update this value for every release!
-set(TCMALLOC_SO_VERSION 9.18.5)
-set(PROFILER_SO_VERSION 5.13.5)
-set(TCMALLOC_AND_PROFILER_SO_VERSION 10.13.6)
-
-# The user can choose not to compile in the heap-profiler, the
-# heap-checker, or the cpu-profiler.  There's also the possibility
-# for a 'fully minimal' compile, which leaves out the stacktrace
-# code as well.  By default, we include all of these that the
-# target system supports.
+# The user can choose not to compile in the heap-profiler, or the
+# cpu-profiler.  There's also the possibility for a 'fully minimal'
+# compile, which leaves out the stacktrace code as well.  By default,
+# we include all of these that the target system supports.
 set(DEFAULT_BUILD_CPU_PROFILER ON)
 set(DEFAULT_BUILD_HEAP_PROFILER ON)
-set(DEFAULT_BUILD_HEAP_CHECKER OFF)
 set(DEFAULT_BUILD_DEBUGALLOC ON)
 set(DEFAULT_BUILD_MINIMAL OFF)
 
@@ -34,11 +27,6 @@
   set(DEFAULT_BUILD_DEBUGALLOC OFF)
 elseif(CYGWIN)
   set(DEFAULT_BUILD_CPU_PROFILER OFF)
-endif()
-
-# Heap checker is Linux-only (and deprecated).
-if(CMAKE_SYSTEM MATCHES Linux)
-  set(DEFAULT_BUILD_HEAP_CHECKER ON)
 endif()
 
 include(CheckCCompilerFlag)
@@ -90,9 +78,6 @@
   GPERFTOOLS_BUILD_HEAP_PROFILER "Build heap-profiler" ${DEFAULT_BUILD_HEAP_PROFILER}
   "NOT gperftools_build_minimal" OFF)
 cmake_dependent_option(
-  GPERFTOOLS_BUILD_HEAP_CHECKER "Build heap-checker" ${DEFAULT_BUILD_HEAP_CHECKER}
-  "NOT gperftools_build_minimal" OFF)
-cmake_dependent_option(
   GPERFTOOLS_BUILD_DEBUGALLOC "Build debugalloc" ${DEFAULT_BUILD_DEBUGALLOC}
   "NOT gperftools_build_minimal" OFF)
 option(
@@ -102,7 +87,6 @@
 if(gperftools_build_minimal)
   set(GPERFTOOLS_BUILD_CPU_PROFILER OFF)
   set(GPERFTOOLS_BUILD_HEAP_PROFILER OFF)
-  set(GPERFTOOLS_BUILD_HEAP_CHECKER OFF)
 endif()
 
 cmake_dependent_option(
@@ -122,6 +106,10 @@
        "Prefer libgcc's _Unwind_Backtrace as default stacktrace capturing method"
        OFF)
 set(PREFER_LIBGCC_UNWINDER ${gperftools_enable_libgcc_unwinder_by_default})
+
+option(gperftools_enable_broken_install_targets
+       "Install .so/.a libraries produced by this project"
+       OFF)
 
 set(gperftools_tcmalloc_pagesize ${default_tcmalloc_pagesize}
   CACHE STRING "Set the tcmalloc internal page size")
@@ -181,23 +169,17 @@
                         void foo(void) __attribute__((aligned(128)));
                         void foo(void) { exit(1); }
                         int main() { return 0; }"
-        HAVE___ATTRIBUTE__ALIGNED_FN) 
+        HAVE___ATTRIBUTE__ALIGNED_FN)
 
 set(CMAKE_EXTRA_INCLUDE_FILES "malloc.h")
-check_type_size("struct mallinfo" STRUCT_MALLINFO LANGUAGE CXX)
-check_type_size("struct mallinfo2" STRUCT_MALLINFO2 LANGUAGE CXX)
 check_function_exists("sbrk" HAVE_SBRK) # for tcmalloc to get memory
 check_function_exists("geteuid" HAVE_GETEUID) # for turning off services when run as root
 check_include_file("features.h" HAVE_FEATURES_H) # for vdso_support.h, Where __GLIBC__ is defined
 check_include_file("malloc.h" HAVE_MALLOC_H) # some systems define stuff there, others not
 check_include_file("glob.h" HAVE_GLOB_H) # for heap-profile-table (cleaning up profiles)
-check_include_file("execinfo.h" HAVE_EXECINFO_H) # for stacktrace? and heapchecker_unittest
-check_include_file("unwind.h" HAVE_UNWIND_H) # for stacktrace
+check_include_file("execinfo.h" HAVE_EXECINFO_H) # for stacktrace
 check_include_file("sched.h" HAVE_SCHED_H) # for being nice in our spinlock code
 check_include_file("sys/syscall.h" HAVE_SYS_SYSCALL_H)
-check_include_file("sys/socket.h" HAVE_SYS_SOCKET_H) # optional; for forking out to symbolizer
-check_include_file("sys/wait.h" HAVE_SYS_WAIT_H) # optional; for forking out to symbolizer
-check_include_file("poll.h" HAVE_POLL_H) # optional; for forking out to symbolizer
 check_include_file("fcntl.h" HAVE_FCNTL_H) # for tcmalloc_unittest
 check_include_file("sys/cdefs.h" HAVE_SYS_CDEFS_H) # Where glibc defines __THROW
 
@@ -213,24 +195,11 @@
 # We override a lot of memory allocation routines, not all of which are
 # standard.  For those the system doesn't declare, we'll declare ourselves.
 set(CMAKE_REQUIRED_DEFINITIONS -D_XOPEN_SOURCE=600)
-check_symbol_exists("cfree" "stdlib.h;malloc.h" HAVE_DECL_CFREE)
 check_symbol_exists("posix_memalign" "stdlib.h;malloc.h" HAVE_DECL_POSIX_MEMALIGN)
 check_symbol_exists("memalign" "stdlib.h;malloc.h" HAVE_DECL_MEMALIGN)
 check_symbol_exists("valloc" "stdlib.h;malloc.h" HAVE_DECL_VALLOC)
 check_symbol_exists("pvalloc" "stdlib.h;malloc.h" HAVE_DECL_PVALLOC)
 set(CMAKE_REQUIRED_DEFINITIONS)
-
-if(HAVE_STRUCT_MALLINFO)
-    set(HAVE_STRUCT_MALLINFO 1)
-else()
-    set(HAVE_STRUCT_MALLINFO 0)
-endif()
-
-if(HAVE_STRUCT_MALLINFO2)
-    set(HAVE_STRUCT_MALLINFO2 1)
-else()
-    set(HAVE_STRUCT_MALLINFO2 0)
-endif()
 
 # We hardcode HAVE_MMAP to 1. There are no interesting systems anymore
 # without functional mmap. And our windows (except mingw) builds
@@ -290,7 +259,7 @@
   set(CMAKE_REQUIRED_FLAGS)
 endif()
 
-check_c_source_compiles("
+check_cxx_source_compiles("
   #include <unwind.h>
   int main()
   {
@@ -302,6 +271,13 @@
   }"
   HAVE_UNWIND_BACKTRACE)
 
+check_cxx_source_compiles("
+#include <cxxabi.h>
+int main() {
+  &__cxxabiv1::__cxa_demangle;
+}"
+  HAVE_CXA_DEMANGLE)
+
 if(enable_backtrace)
   set(default_emergency_malloc ON)
 else()
@@ -319,15 +295,6 @@
 check_c_source_compiles(
   "int main() { return __builtin_expect(main != 0, 1); }"
   HAVE_BUILTIN_EXPECT)
-
-check_c_source_compiles("
-  #include <unistd.h>
-  int main()
-  {
-    char** env = __environ;
-    return 0;
-  }"
-  HAVE___ENVIRON)
 
 if(enable_backtrace)
   check_symbol_exists("backtrace" "execinfo.h" HAVE_DECL_BACKTRACE)
@@ -349,3 +316,39 @@
 
 if(MINGW)
   check_symbol_exists("sleep" "unistd.h" HAVE_DECL_SLEEP)
+  check_symbol_exists("nanosleep" "time.h" HAVE_DECL_NANOSLEEP)
+endif()
+
+if(LINUX)
+  check_c_source_compiles("
+    #include <signal.h>
+    #include <time.h>
+    int main() { return SIGEV_THREAD_ID || CLOCK_THREAD_CPUTIME_ID; }"
+    HAVE_LINUX_SIGEV_THREAD_ID)
+endif()
+
+# Disable large allocation report by default.
+option(gperftools_enable_large_alloc_report
+      "Report very large allocations to stderr"
+      OFF)
+set(ENABLE_LARGE_ALLOC_REPORT ${gperftools_enable_large_alloc_report})
+
+# Enable aggressive decommit by default
+option(gperftools_enable_aggressive_decommit_by_default
+      "Enable aggressive decommit by default"
+      OFF)
+set(ENABLE_AGGRESSIVE_DECOMMIT_BY_DEFAULT ${gperftools_enable_aggressive_decommit_by_default})
+
+
+configure_file(cmake/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY)
+
+if(GPERFTOOLS_BUILD_CPU_PROFILER OR
+   GPERFTOOLS_BUILD_HEAP_PROFILER)
+  set(WITH_STACK_TRACE ON)
+endif()
+
+include_directories($<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/>)
+# This is so we can #include <gperftools/foo>
+include_directories($<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>)
+
+if(NOT WITH_STACK_TRACE)

=== debian/changelog ===
google-perftools (2.18-1) unstable; urgency=medium

  * New upstream release.
  * Remove google-perftools package, binaries no longer shipped
    (closes: #1049383).
  * Remove now redundant Rules-Requires-Root value.
  * Update watch file.
  * Refer online version of Free Software Foundation licence.
  * Update Standards-Version to 4.7.2 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 14 Feb 2026 11:53:31 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,8 @@
 Section: libs
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), libunwind-dev [amd64]
-Build-Conflicts: autoconf2.13, automake1.4
-Standards-Version: 4.6.2
-Rules-Requires-Root: no
+Build-Depends: debhelper-compat (= 13), libunwind-dev [amd64]
+Standards-Version: 4.7.2
 Homepage: https://github.com/gperftools/gperftools
 Vcs-Git: https://salsa.debian.org/debian/google-perftools.git
 Vcs-Browser: https://salsa.debian.org/debian/google-perftools
@@ -47,14 +45,3 @@
  utilities to improve and analyze the performance of C++ programs. This includes
  the full features: an optimized thread-caching malloc() and cpu and heap
  profiling utilities.
-
-Package: google-perftools
-Section: devel
-Architecture: all
-Depends: ${misc:Depends}, ${perl:Depends}, libgoogle-perftools4t64, curl
-Suggests: libgoogle-perftools-dev
-Recommends: graphviz, gv
-Description: command line utilities to analyze the performance of C++ programs
- The gperftools, previously called google-perftools, package contains some
- utilities to improve and analyze the performance of C++ programs. This is a
- part of that package, and includes command line utilities.

=== debian/rules ===
--- 
+++ 
@@ -12,16 +12,9 @@
 
 override_dh_auto_install:
 	dh_auto_install
-	# rename binary
-	cd $(DESTDIR)/usr/bin && mv pprof google-pprof
-	cd $(DESTDIR)/usr/share/man/man1 && \
-		mv pprof.1 google-pprof.1 && \
-		sed -i 's/pprof/google-pprof/g' google-pprof.1
-	cd $(DESTDIR)/usr/share/doc/gperftools/ && \
-		sed -i 's/pprof/google-pprof/g' README
 	# remove unwanted documentation
 	cd $(DESTDIR)/usr/share/doc/gperftools/ && \
-		rm -f ChangeLog ChangeLog.old INSTALL README_windows.txt TODO
+		rm -f ChangeLog.old INSTALL README_windows.txt
 	# remove .la files
 	find $(DESTDIR) -name \*.la -exec rm {} \;

=== debian/watch ===
Version: 5

Template: Github
Owner: gperftools
Project: gperftools
